"""
    A Report plugin to save a report to a fixed mail address.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
"""


import os
from report.io import DisplaySuccessMessage
from report.io import DisplayFailMessage
from report import _report as _

import report as reportmodule

import commands

def labelFunction(label):
	if label:
		return label
	return 'mail to Asianux'
def descriptionFunction(optionsDict):
	if optionsDict.has_key('description'):
		return optionsDict['description']
	return "send the problem to a fixed mailbox"

def report(signature, io, optionsDict):
	if not io:
		DisplayFailMessage(None,_("NO IO"),_("No io provided."))
		return False

	fileName = reportmodule.serializeToFile(signature,io)

	if fileName is None:
		return None

	elif fileName is False:
		return False

	else:
		return mailFile(fileName, io, optionsDict)


def mailFile(fileName, io, optionsDict):	

	tomailaddr = "feedback@asianux.com"
	if optionsDict.has_key('addr'):
		frommailaddr = optionsDict['addr']
	else:
		frommailaddr = io.queryField(_("The mail address to reply you:"))
	if frommailaddr == None:
		return None
	if not frommailaddr or frommailaddr.strip() == "":
		DisplayFailMessage(io,_("Mail failed"),_("Please provide a reply mail address!"))
		return False
		
	try:
		(reval,output) = commands.getstatusoutput('mail -s %s -r %s %s < %s' % (fileName,frommailaddr,tomailaddr,fileName))
	except EnvironmentError:
		DisplayFailMessage(io,_("Mail failed"),_("system commands run failed!"))
                return False

	if reval != 0:
		DisplayFailMessage(io, _("Mail failed"),
                               _("Could not send mail, please choose other choice."))
        	return False
	else:
		DisplaySuccessMessage(io, _("Mail successfully"),
                          _("Mail is sent successfully to:"),None,tomailaddr)
		return True
